(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("classnames"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "classnames"], factory);
	else if(typeof exports === 'object')
		exports["ReactTightForms"] = factory(require("react"), require("classnames"));
	else
		root["ReactTightForms"] = factory(root["React"], root["classNames"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.TightFormLabel = exports.TightFormInput = exports.TightFormGroup = exports.TightFormContainer = exports.TightForm = undefined;

	var _TightForm = __webpack_require__(1);

	var _TightForm2 = _interopRequireDefault(_TightForm);

	var _TightFormContainer = __webpack_require__(4);

	var _TightFormContainer2 = _interopRequireDefault(_TightFormContainer);

	var _TightFormGroup = __webpack_require__(5);

	var _TightFormGroup2 = _interopRequireDefault(_TightFormGroup);

	var _TightFormInput = __webpack_require__(6);

	var _TightFormInput2 = _interopRequireDefault(_TightFormInput);

	var _TightFormLabel = __webpack_require__(7);

	var _TightFormLabel2 = _interopRequireDefault(_TightFormLabel);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.TightForm = _TightForm2.default;
	exports.TightFormContainer = _TightFormContainer2.default;
	exports.TightFormGroup = _TightFormGroup2.default;
	exports.TightFormInput = _TightFormInput2.default;
	exports.TightFormLabel = _TightFormLabel2.default;
	exports.default = {
	  TightForm: _TightForm2.default,
	  TightFormContainer: _TightFormContainer2.default,
	  TightFormGroup: _TightFormGroup2.default,
	  TightFormInput: _TightFormInput2.default,
	  TightFormLabel: _TightFormLabel2.default
	};

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(3);

	var _classnames2 = _interopRequireDefault(_classnames);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var TightForm = _react2.default.createClass({
	  displayName: 'TightForm',

	  propTypes: {
	    /**
	     * Can be a tag name (eg. "div", "form", etc.) or a React component class.
	     *
	     * defaults to "div"
	     */
	    Component: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.func, _react2.default.PropTypes.string]),

	    /**
	     * Children for the <TightForm>. They *should* be <TightFormGroup>'s.
	     */
	    children: _react2.default.PropTypes.node,

	    /**
	     * The css class name of the root element.
	     */
	    className: _react2.default.PropTypes.string,

	    /**
	     * If this is the <TightForm> element within the parent container, set
	     * this to `true` so we can disable the "border-bottom" CSS prop.
	     *
	     * defaults to `false`
	     */
	    last: _react2.default.PropTypes.bool,

	    /**
	     * Override the inline-styles of the root element.
	     */
	    style: _react2.default.PropTypes.object
	  },

	  getDefaultProps: function getDefaultProps() {
	    return {
	      Component: 'div',
	      last: false
	    };
	  },
	  render: function render() {
	    var _props = this.props;
	    var Component = _props.Component;
	    var children = _props.children;
	    var className = _props.className;
	    var last = _props.last;

	    var others = _objectWithoutProperties(_props, ['Component', 'children', 'className', 'last']);

	    var classes = (0, _classnames2.default)(className, {
	      "react-tight-form": true,
	      "last": last
	    });

	    return _react2.default.createElement(
	      Component,
	      _extends({}, others, { className: classes }),
	      children
	    );
	  }
	});

	exports.default = TightForm;
	module.exports = exports['default'];

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(3);

	var _classnames2 = _interopRequireDefault(_classnames);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var TightFormContainer = _react2.default.createClass({
	  displayName: 'TightFormContainer',

	  propTypes: {
	    /**
	     * Can be a tag name (eg. "div", "form", etc.) or a React component class.
	     *
	     * defaults to "div"
	     */
	    Component: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.func, _react2.default.PropTypes.string]),

	    /**
	     * Children for the <TightFormContainer>. They *should* be <TightForm>'s.
	     */
	    children: _react2.default.PropTypes.node,

	    /**
	     * The css class name of the root element.
	     */
	    className: _react2.default.PropTypes.string,

	    /**
	     * Override the inline-styles of the root element.
	     */
	    style: _react2.default.PropTypes.object
	  },

	  getDefaultProps: function getDefaultProps() {
	    return {
	      Component: 'div'
	    };
	  },
	  render: function render() {
	    var _props = this.props;
	    var Component = _props.Component;
	    var children = _props.children;
	    var className = _props.className;

	    var others = _objectWithoutProperties(_props, ['Component', 'children', 'className']);

	    var classes = (0, _classnames2.default)(className, 'react-tight-form-container');

	    return _react2.default.createElement(
	      Component,
	      _extends({}, others, { className: classes }),
	      children
	    );
	  }
	});

	exports.default = TightFormContainer;
	module.exports = exports['default'];

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(3);

	var _classnames2 = _interopRequireDefault(_classnames);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var TightFormGroup = _react2.default.createClass({
	  displayName: 'TightFormGroup',

	  propTypes: {
	    /**
	     * Children for the <TightFormGroup>. They *should* be <TightFormLabel> or
	     * <TightFormInput>'s.
	     */
	    children: _react2.default.PropTypes.node,

	    /**
	     * The css class name of the root element.
	     */
	    className: _react2.default.PropTypes.string,

	    /**
	     * Override the inline-styles of the root element.
	     */
	    style: _react2.default.PropTypes.object,

	    /**
	     * This component includes validation styles for error, warning, and
	     * success states on form controls and labels.
	     */
	    validationState: _react2.default.PropTypes.oneOf(['success', 'warning', 'error'])
	  },

	  render: function render() {
	    var _props = this.props;
	    var children = _props.children;
	    var className = _props.className;
	    var validationState = _props.validationState;

	    var others = _objectWithoutProperties(_props, ['children', 'className', 'validationState']);

	    var validationStyle = validationState ? 'has-' + validationState : undefined;
	    var classes = (0, _classnames2.default)(className, 'react-tight-form-group', validationStyle);

	    return _react2.default.createElement(
	      'div',
	      _extends({}, others, { className: classes }),
	      children
	    );
	  }
	});

	exports.default = TightFormGroup;
	module.exports = exports['default'];

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
	                                                                                                                                                                                                                                                                   * The <TightFormInput> component renders an input in ReactTightForm wrappers.
	                                                                                                                                                                                                                                                                   *
	                                                                                                                                                                                                                                                                   * Supports label, help, text input add-ons, validation and use as wrapper.
	                                                                                                                                                                                                                                                                   *
	                                                                                                                                                                                                                                                                   * If you don't want the <TightFormInput> to act as a wrapper, set the prop
	                                                                                                                                                                                                                                                                   * named "standalone" and this component will take care of setting up the
	                                                                                                                                                                                                                                                                   * appropriate CSS classes.
	                                                                                                                                                                                                                                                                   *
	                                                                                                                                                                                                                                                                   * Use "getValue()" or "getChecked()" to get the current state. The helper
	                                                                                                                                                                                                                                                                   * method "getInputDOMNode()" returns the internal input element.
	                                                                                                                                                                                                                                                                   *
	                                                                                                                                                                                                                                                                   * **NOTE** This component does not support multi-select field at this
	                                                                                                                                                                                                                                                                   * moment.
	                                                                                                                                                                                                                                                                   */

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(3);

	var _classnames2 = _interopRequireDefault(_classnames);

	var _TightFormGroup = __webpack_require__(5);

	var _TightFormGroup2 = _interopRequireDefault(_TightFormGroup);

	var _TightFormLabel = __webpack_require__(7);

	var _TightFormLabel2 = _interopRequireDefault(_TightFormLabel);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	function defaultWrapperTemplate(props, input) {
	  return input;
	}

	function _isCheckboxOrRadio(props) {
	  return props.type === 'checkbox' || props.type === 'radio';
	}

	function makeInputClassName(props) {
	  var validationClassName = props.validationState ? 'has-' + props.validationState : undefined;
	  return (0, _classnames2.default)(props.className, {
	    "react-tight-form-control": !_isCheckboxOrRadio(props),
	    "hide": props.hideRightBorder // does nothing if checkbox/radio
	  }, validationClassName);
	}

	var TightFormInput = _react2.default.createClass({
	  displayName: 'TightFormInput',

	  propTypes: {
	    /**
	     * This is used primarily for <select> fields (eg. <option> list). If this
	     * component is not of type "select", this will be ignored.
	     */
	    children: _react2.default.PropTypes.node,

	    /**
	     * The css class name of the <input>/<select> element.
	     */
	    className: _react2.default.PropTypes.string,

	    /**
	     * Disables the input field if set to `true`.
	     *
	     * defaults to `false`
	     */
	    disabled: _react2.default.PropTypes.bool,

	    /**
	     * Props to pass into the <TightFormGroup> component.
	     */
	    groupProps: _react2.default.PropTypes.object,

	    /**
	     * Set this to `true` so we can disable the right-border.
	     *
	     * defaults to `false`
	     */
	    hideRightBorder: _react2.default.PropTypes.bool,

	    /**
	     * The id prop for the input field. This is *REQUIRED* if this input type
	     * is "checkbox" or "radio"
	     */
	    id: function id(props) {
	      if (_isCheckboxOrRadio(props)) {
	        if (!props.id) {
	          return new Error('checkbox or radio inputs require the "id" prop to\n            be set.');
	        }
	      }
	    },

	    /**
	     * Label for this input.
	     *
	     * If this is not set, no <TightFormLabel> element will be rendered.
	     */
	    label: _react2.default.PropTypes.node,

	    /**
	     * Props for the <TightFormLabel> component. This is only valid if the
	     * "label" prop has been set.
	     */
	    labelProps: _react2.default.PropTypes.object,

	    /**
	     * Optional placeholder text to display to the user. This applies to
	     * input fields that support this prop (eg. "text", "number", etc.).
	     */
	    placeholder: _react2.default.PropTypes.string,

	    /**
	     * Provide a name for the input element.
	     *
	     * If this component is a "radio" type, this field *should* be set.
	     */
	    name: _react2.default.PropTypes.string,

	    /**
	     * set this to `true` to prevent this component from acting as a
	     * <TightFormGroup> wrapper.
	     *
	     * defaults to `false`
	     */
	    standalone: _react2.default.PropTypes.bool,

	    /**
	     * Override the inline-styles of the root element.
	     */
	    style: _react2.default.PropTypes.object,

	    /**
	     * Specifies the type of input to display such as "password" or "text".
	     */
	    type: _react2.default.PropTypes.oneOf(['checkbox', 'email', 'number', 'password', 'radio', 'select', 'text']),

	    /**
	     * This component includes validation styles for error, warning, and
	     * success states on form controls and labels.
	     *
	     * If this is a "standalone" component, we will apply the state to the
	     * element.
	     */
	    validationState: _react2.default.PropTypes.oneOf(['success', 'warning', 'error']),

	    /**
	     * Sometimes you might need to render your inputs within a container /
	     * wrapper.
	     *
	     * For example, suppose you want an <input> "typeahead" feature or display
	     * a pretty "search" font-awesome icon. You can do so by passing in a
	     * custom "template" function which will receive the same props that
	     * <TightFormInput> has received.
	     *
	     * **NOTE** DO NOT MUTATE "props".
	     *
	     * @param {object} props
	     * @param {ReactElement} input
	     */
	    wrapperTemplate: _react2.default.PropTypes.func
	  },

	  getDefaultProps: function getDefaultProps() {
	    return {
	      disabled: false,
	      hideRightBorder: false,
	      standalone: false,
	      wrapperTemplate: defaultWrapperTemplate
	    };
	  },
	  render: function render() {
	    var _props = this.props;
	    var _props$groupProps = _props.groupProps;
	    var groupProps = _props$groupProps === undefined ? {} : _props$groupProps;
	    var standalone = _props.standalone;
	    var validationState = _props.validationState;
	    var wrapperTemplate = _props.wrapperTemplate;

	    var input = wrapperTemplate(this.props, this.renderInput());

	    if (standalone) {
	      return input;
	    }

	    /**
	     * Checkbox and radio input come back as an Array.
	     */
	    if (_react2.default.isValidElement(input)) {
	      input = _react2.default.cloneElement(input, { key: 'input' });
	    }

	    return _react2.default.createElement(
	      _TightFormGroup2.default,
	      _extends({}, groupProps, { validationState: validationState }),
	      this.isCheckboxOrRadio() ? this.renderLabel(input) : [this.renderLabel(), input]
	    );
	  },
	  renderLabel: function renderLabel(children) {
	    var _props2 = this.props;
	    var id = _props2.id;
	    var hideRightBorder = _props2.hideRightBorder;
	    var label = _props2.label;
	    var _props2$labelProps = _props2.labelProps;
	    var labelProps = _props2$labelProps === undefined ? {} : _props2$labelProps;

	    var className = labelProps.className;

	    if (this.isCheckboxOrRadio()) {
	      var classes = (0, _classnames2.default)({
	        "react-tight-checkbox-radio-group": true,
	        "last": hideRightBorder
	      });

	      return _react2.default.createElement(
	        'div',
	        { key: 'label', className: classes },
	        children,
	        label && _react2.default.createElement(
	          'label',
	          _extends({}, labelProps, {
	            className: (0, _classnames2.default)(className, 'checkbox-label'),
	            htmlFor: id
	          }),
	          label
	        )
	      );
	    } else {
	      return label ? _react2.default.createElement(
	        _TightFormLabel2.default,
	        _extends({}, labelProps, {
	          key: 'label',
	          className: className,
	          htmlFor: id
	        }),
	        label
	      ) : children;
	    }
	  },
	  renderInput: function renderInput() {
	    var _props3 = this.props;
	    var children = _props3.children;
	    var className = _props3.className;
	    var disabled = _props3.disabled;
	    var groupProps = _props3.groupProps;
	    var hideRightBorder = _props3.hideRightBorder;
	    var id = _props3.id;
	    var label = _props3.label;
	    var labelProps = _props3.labelProps;
	    var standalone = _props3.standalone;
	    var type = _props3.type;
	    var validationState = _props3.validationState;
	    var wrapperTemplate = _props3.wrapperTemplate;

	    var others = _objectWithoutProperties(_props3, ['children', 'className', 'disabled', 'groupProps', 'hideRightBorder', 'id', 'label', 'labelProps', 'standalone', 'type', 'validationState', 'wrapperTemplate']);

	    switch (type) {
	      case 'select':
	        return _react2.default.createElement(
	          'select',
	          _extends({}, others, {
	            ref: 'input',
	            id: id,
	            disabled: disabled,
	            className: makeInputClassName(this.props)
	          }),
	          children
	        );
	      case 'checkbox':
	        return [_react2.default.createElement('input', _extends({}, others, {
	          key: 'checkbox-input',
	          ref: 'input',
	          id: id,
	          disabled: disabled,
	          type: type,
	          className: makeInputClassName(this.props)
	        })), _react2.default.createElement('label', { key: 'checkbox-label', htmlFor: id })];
	      case 'radio':
	        return [_react2.default.createElement('input', _extends({}, others, {
	          key: 'radio-input',
	          ref: 'input',
	          id: id,
	          disabled: disabled,
	          type: type,
	          className: makeInputClassName(this.props)
	        })), _react2.default.createElement('label', { key: 'radio-label', htmlFor: id })];
	        break;
	      // case 'text':
	      // case 'number':
	      default:
	        return _react2.default.createElement('input', _extends({}, others, {
	          ref: 'input',
	          id: id,
	          disabled: disabled,
	          type: type,
	          className: makeInputClassName(this.props)
	        }));
	    }
	  },
	  getChecked: function getChecked() {
	    return this.getInputDOMNode().checked;
	  },
	  getInputDOMNode: function getInputDOMNode() {
	    return this.refs.input;
	  },
	  getSelectedOptions: function getSelectedOptions() {
	    var values = [];

	    Array.prototype.forEach.call(this.getInputDOMNode().getElementsByTagName('option'), function (option) {
	      if (option.selected) {
	        var value = option.getAttribute('value') || option.innerHtml;
	        values.push(value);
	      }
	    });

	    return values;
	  },
	  getValue: function getValue() {
	    var _props4 = this.props;
	    var multiple = _props4.multiple;
	    var type = _props4.type;

	    if (type) {
	      if (type === 'select' && multiple) {
	        return this.getSelectedOptions();
	      }
	      return this.getInputDOMNode().value;
	    }
	    throw new Error('Cannot use getValue without specifying input type.');
	  },
	  isCheckboxOrRadio: function isCheckboxOrRadio() {
	    return _isCheckboxOrRadio(this.props);
	  },
	  isFile: function isFile() {
	    return this.props.type === 'file';
	  }
	});

	exports.default = TightFormInput;
	module.exports = exports['default'];

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	var _classnames = __webpack_require__(3);

	var _classnames2 = _interopRequireDefault(_classnames);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	var TightFormLabel = _react2.default.createClass({
	  displayName: 'TightFormLabel',

	  propTypes: {
	    /**
	     * Can be a tag name (eg. "div", "form", etc.) or a React component class.
	     *
	     * defaults to "label"
	     */
	    Component: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.func, _react2.default.PropTypes.string]),

	    /**
	     * Children for the <TightForm>. They *should* be <TightFormGroup>'s.
	     */
	    children: _react2.default.PropTypes.node,

	    /**
	     * The css class name of the root element.
	     */
	    className: _react2.default.PropTypes.string,

	    /**
	     * If this item is the last in the form, set this to `true` to disable the
	     * right border.
	     *
	     * defaults to `false`
	     */
	    last: _react2.default.PropTypes.bool,

	    /**
	     * Override the inline-styles of the root element.
	     */
	    style: _react2.default.PropTypes.object
	  },

	  getDefaultProps: function getDefaultProps() {
	    return {
	      Component: 'label',
	      last: false
	    };
	  },
	  render: function render() {
	    var _props = this.props;
	    var Component = _props.Component;
	    var children = _props.children;
	    var className = _props.className;
	    var last = _props.last;

	    var others = _objectWithoutProperties(_props, ['Component', 'children', 'className', 'last']);

	    var classes = (0, _classnames2.default)(className, {
	      "react-tight-form-control-label": true,
	      "last": last
	    });

	    return _react2.default.createElement(
	      Component,
	      _extends({}, others, { className: classes }),
	      children
	    );
	  }
	});

	exports.default = TightFormLabel;
	module.exports = exports['default'];

/***/ }
/******/ ])
});
;