import React from 'react';
import classNames from 'classnames';

const TightForm = React.createClass({

  propTypes: {
    /**
     * Can be a tag name (eg. "div", "form", etc.) or a React component class.
     *
     * defaults to "div"
     */
    Component: React.PropTypes.oneOfType([
      React.PropTypes.func,
      React.PropTypes.string
    ]),

    /**
     * Children for the <TightForm>. They *should* be <TightFormGroup>'s.
     */
    children: React.PropTypes.node,

    /**
     * The css class name of the root element.
     */
    className: React.PropTypes.string,

    /**
     * If this is the <TightForm> element within the parent container, set
     * this to `true` so we can disable the "border-bottom" CSS prop.
     *
     * defaults to `false`
     */
    last: React.PropTypes.bool,

    /**
     * Override the inline-styles of the root element.
     */
    style: React.PropTypes.object
  },

  getDefaultProps() {
    return {
      Component: 'div',
      last: false
    };
  },

  render() {
    const {
      Component,
      children,
      className,
      last,
      ...others
    } = this.props;
    const classes = classNames(className, {
      "react-tight-form": true,
      "last": last
    });

    return (
      <Component {...others} className={classes}>
        {children}
      </Component>
    );
  }

});

export default TightForm;