import React from 'react';
import classNames from 'classnames';

const TightFormContainer = React.createClass({

  propTypes: {
    /**
     * Can be a tag name (eg. "div", "form", etc.) or a React component class.
     *
     * defaults to "div"
     */
    Component: React.PropTypes.oneOfType([
      React.PropTypes.func,
      React.PropTypes.string
    ]),

    /**
     * Children for the <TightFormContainer>. They *should* be <TightForm>'s.
     */
    children: React.PropTypes.node,

    /**
     * The css class name of the root element.
     */
    className: React.PropTypes.string,

    /**
     * Override the inline-styles of the root element.
     */
    style: React.PropTypes.object
  },

  getDefaultProps() {
    return {
      Component: 'div'
    };
  },

  render() {
    const {
      Component,
      children,
      className,
      ...others
    } = this.props;
    const classes = classNames(className, 'react-tight-form-container');

    return (
      <Component {...others} className={classes}>
        {children}
      </Component>
    );
  }

});

export default TightFormContainer;